petsc-3.10.5 2019-03-28
Report Typos and Errors

# MatCreateSeqAIJViennaCL

Creates a sparse matrix in AIJ (compressed row) format (the default parallel PETSc format). This matrix will ultimately be pushed down to GPUs and use the ViennaCL library for calculations. For good matrix assembly performance the user should preallocate the matrix storage by setting the parameter nz (or the array nnz). By setting these parameters accurately, performance during matrix assembly can be increased substantially.

### Synopsis

    #include "petscmat.h"
    PetscErrorCode  MatCreateSeqAIJViennaCL(MPI_Comm comm,PetscInt m,PetscInt n,PetscInt nz,const PetscInt nnz[],Mat *A)

Collective on MPI_Comm

### Input Parameters

| comm | - MPI communicator, set to PETSC_COMM_SELF
| m | - number of rows
| n | - number of columns
| nz | - number of nonzeros per row (same for all rows)
| nnz | - array containing the number of nonzeros in the various rows (possibly different for each row) or NULL

### Output Parameter

A -the matrix

It is recommended that one use the MatCreate(), MatSetType() and/or MatSetFromOptions(), MatXXXXSetPreallocation() paradigm instead of this routine directly. [MatXXXXSetPreallocation() is, for example, MatSeqAIJSetPreallocation]

### Notes

If nnz is given then nz is ignored

The AIJ format (also called the Yale sparse matrix format or compressed row storage), is fully compatible with standard Fortran 77 storage. That is, the stored row and column indices can begin at either one (as in Fortran) or zero. See the users' manual for details.

Specify the preallocated storage with either nz or nnz (not both). Set nz=PETSC_DEFAULT and nnz=NULL for PETSc to control dynamic memory allocation. For large problems you MUST preallocate memory or you will get TERRIBLE performance, see the users' manual chapter on matrices.

### See Also

MatCreate(), MatCreateAIJ(), MatCreateAIJCUSPARSE(), MatSetValues(), MatSeqAIJSetColumnIndices(), MatCreateSeqAIJWithArrays(), MatCreateAIJ()

### Level

intermediate

### Location

src/mat/impls/aij/seq/seqviennaclcuda/aijviennaclcuda.cu
Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages